#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h> 

/* fonction that examine the termination status returned by wait and waitpid */ 
/* Parameter IN : int filed by API : wait or waipid or wait3, wait4 under BSD */ 

void pr_exit (int status)
{
/* True if status was returned for a child that terminated normally. */
 	if (WIFEXITED(status) ) 
		/* In this case we can execute WEXITSTATUS */
		/* fetch the low-order 8 bits of the arguments that the child passed to exit */
		printf("Normal Termination, exit status = %d \n", WEXITSTATUS(status) ) ; 
	/* Case were status was returned for a child that terminated abnormally (by receipt of
	 a signal that it didn't cache) */
	else if (WIFSIGNALED(status) ) 
		/* fetch the signal that cause the termination */
		printf("abnormal Termination, signal number = %d %s \n", WTERMSIG(status) , 


#ifdef WCOREDUMP
		WCOREDUMP(status) ? " (Core file generated) " : "") ; 
#else 
		"");
#endif 
	/* True if status status was returned for a child that is currently stop */
    else if (WIFSTOPPED(status))
	    /* fetch the signal number that caused the child to stop */
    	printf("Child stopped, signal number = %d\n", WSTOPSIG(status)); 
}
		

void 
return_exec_debug (char *argv[])
{
  /* the exec did not work */
  switch (errno)
    {
    case E2BIG:
      printf (" Argv or envp lists too big\n");
      break;
    case EACCES:
      printf (" No execute acces on file %s\n", argv[1]);
      break;
    case EFAULT:
      printf ("%s contains invalid adress\n", argv[1]);
      break;
    case ENAMETOOLONG:
      printf ("%s specifies a name file too long\n", argv[1]);
      break;
    case ENOENT:
      printf ("%s specifies a noexistent file\n", argv[1]);
      break;
    case ELOOP:
      printf ("Symbolics links have been encountered\n");
      break;
      //case ENOEXE:  /* Not in Linux 2.2.13 */
      //  printf("%s is not an executable file",argv[1]);
    case ENOMEM:
      printf ("Not enough available memory to launch:%s\n", argv[1]);
      break;
    case ENOTDIR:
      printf ("There is a wrong dir in :%s\n", argv[1]);
      break;
    case EPERM:
      printf ("FileSys that contain :%s can't permit execut\n", argv[1]);
      break;

    }				/* end of switch */
}				/* end of return_exec_debug */



