/* version  2 : XSiquin : 11/11/99 */ 
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include <wait.h>
#include </usr/include/sys/times.h>
#include <limits.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <errno.h>

#include "bib_sys.h" /*my own bib */

/* function prototypes */

static void pr_times (clock_t, struct tms *, struct tms *);
void return_exec_debug (char **);

int
main (int argc, char *argv[], char *envp[])
{
  int return_wait;		/* test the return of wait */
  int return_getrusage;		/* test the return of getrusage*/
  pid_t return_fork;		/* pid_t returned by fork */
  int return_exec;		/* value of return of exec** function */
  int *status;			/* status receveid in a wait , waitpid...etc */
  struct rusage *rusage;	/* structure existing in wait3, wait4, BSD style */
  char buf[1023];		/* buffer to get the current directory */
  int cpt;			/* for loop to print parameters passed to main */

  struct tms tmsstart, tmsend;
  clock_t start, end;

  rusage = (struct rusage *) malloc (sizeof (struct rusage));

  printf ("Parameters (command executed)passed to the main:%s\n", argv[0]);
  printf ("Parameters passed to the main that we want to time:\n");

  if (argc < 2)
    {
      printf ("Usage : time <commande you want to time>\n");
      exit (1);
    }
  for (cpt = 0; cpt < argc; cpt++)
    printf ("Parameters : %d passed to the main e:%s\n", cpt, argv[cpt]);
  for (cpt = 0; envp[cpt] != NULL; cpt++)
    printf ("Environment: %d of the current process:%s\n", cpt, envp[cpt]);

  if ((start = times (&tmsstart)) == -1)	/* starting values */
    perror ("error in times");

  switch ((return_fork = fork ()))
    {

    case 0:
      /* son code */
      printf ("******SON******\n");
      printf ("pid du fils:%d\n", (int) getpid ());
      printf ("PROCESS's working directory :%s\n", getcwd (buf, sizeof (buf)));
      /* in the son we will execute a differrent image */
      /* the environnement is preserved */
      printf ("Launch recover API with command: %s\n", argv[1]);
      return_exec = execvp (argv[1], argv);
      printf ("return_exec only printed if exec failed: %d\n", return_exec);
      perror ("Problem with exec function\n");

      /* errors management */
      if (return_exec == -1)
	{
	  return_exec_debug (argv);
	}

    default:
      /* father code */

      /* Different manner to wait for the son */
      //return_wait = wait (status);	/* this is blocking in case we have many children */
      /* two manners not blocking */
      /* return_wait = waitpid(return_fork,status,WNOHANG) ; */
         return_wait = wait4(return_fork,status, WUNTRACED, rusage); 

      /* At this point, the father should have received SIGCHLD */
      /* The default action for this signaled is to be ignored */

      printf ("******PERE******\n");

      if ((end = times (&tmsend)) == -1)	/* ending values */
	perror ("error in times");

      printf ("fork return value:%d\n", return_fork);
      printf ("wait return value:%d\n", return_wait);
      printf ("******FATHER AFTER EXECLP AND DEAD ON THE SON ******\n");

      /* First method : only works with wait3 because of the rusage struct */
      if ((return_getrusage = getrusage (RUSAGE_CHILDREN, rusage)) == -1)
	perror ("Perror_message Error getrusage");
      if (errno == EFAULT)
	printf ("ERRNO = EFAULT\n");
      else
	{
  printf ("Ressources used in User mode by the son given by struct rusage %10.9f\n", (rusage->ru_utime).tv_usec);
  printf ("Ressources used in System mode by the son given by struct rusage %10.9f\n", (rusage->ru_stime).tv_usec);
	}
      /* second methods, does depend structure tms and not on rusage */
      pr_times (end - start, &tmsstart, &tmsend);



    }				/* End of switch */

  return (1);			/* return code for the OS ; status code  for the shell */

  free (rusage);
}				/* end of main */


static void
pr_times (clock_t real, struct tms *tmsstart, struct tms *tmsend)
{
  static long clktck = 0;
  /* clock ticks is 100 per second under Linux 2.2.13 */
  if (clktck == 0)		/* fetch clock tips per second first time ; depends on architecure */
    if ((clktck = sysconf (_SC_CLK_TCK)) < 0)
      perror ("error in sysconf");

  fprintf (stderr, "\nreal:  %7.2f\n", real / (double) clktck);
  fprintf (stderr, "user:  %7.2f\n", (tmsend->tms_utime - tmsstart->tms_utime) / (double) clktck);
  fprintf (stderr, "sys:  %7.2f\n", (tmsend->tms_stime - tmsstart->tms_stime) / (double) clktck);
  fprintf (stderr, "Child user:  %7.2f\n", (tmsend->tms_cutime - tmsstart->tms_cutime) / (double) clktck);
  fprintf (stderr, "Child sys:  %7.2f\n", (tmsend->tms_cstime - tmsstart->tms_cstime) / (double) clktck);
}
